
(ld "/home/waqar/Downloads/HOL-ACL2 Code/alter_seq_error_bound/expt-macl-error-bound_new.lisp")

(defthm abs-expt-error-bound-tri
  (implies (and (rationalp x)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n))
           (equal (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                             (-(expt-minus-maclaurin x2 0 (+ k 1 n)))
                             (expt-minus-maclaurin x3 0 (+ k 1 n)))
                          (+ (expt-minus-maclaurin x1 0 k)
                             (-(expt-minus-maclaurin x2 0 k))
                             (expt-minus-maclaurin x3 0 k))))
                  (abs (+ (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                              (expt-minus-maclaurin x1 0 k))
                          (- (expt-minus-maclaurin x2 0 k)
                              (expt-minus-maclaurin x2 0 (+ k 1 n)))
                          (- (expt-minus-maclaurin x3 0 (+ k 1 n))
                              (expt-minus-maclaurin x3 0 k))))))


)

(defthm abs-expt-error-bound-tri-1
  (implies (and (rationalp x)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n))
           (<= (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (-(expt-minus-maclaurin x2 0 (+ k 1 n)))
                          (expt-minus-maclaurin x3 0 (+ k 1 n)))
                       (+ (expt-minus-maclaurin x1 0 k)
                          (-(expt-minus-maclaurin x2 0 k))
                          (expt-minus-maclaurin x3 0 k))))
               (+ (abs (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (expt-minus-maclaurin x1 0 k)))
                  (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                          (expt-minus-maclaurin x2 0 k)))
                  (abs (- (expt-minus-maclaurin x3 0 (+ k 1 n))
                          (expt-minus-maclaurin x3 0 k)))))))

(defthm abs-expt-error-bound-tri-2
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k)
                (<= (big-index) k))
           (<= (+ (abs (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (expt-minus-maclaurin x1 0 k)))
                  (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                          (expt-minus-maclaurin x2 0 k)))
                  (abs (- (expt-minus-maclaurin x3 0 (+ k 1 n))
                          (expt-minus-maclaurin x3 0 k))))
               (+ (expt-div-fact x1 (+ k 1))
                  (expt-div-fact x2 (+ k 1))
                  (expt-div-fact x3 (+ k 1)))))
:hints (("Goal"
         :use
         ((:instance abs-expt-error-bound1
                     (x x1))
          (:instance abs-expt-error-bound1
                     (x x2))
          (:instance abs-expt-error-bound1
                     (x x3)))))
)


(defthm abs-expt-error-bound-tri-3
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (< 0 x1)
                (< 0 x2) 
                (< 0 x3)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k)
                (<= (big-index) k))
           (<= (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (-(expt-minus-maclaurin x2 0 (+ k 1 n)))
                          (expt-minus-maclaurin x3 0 (+ k 1 n)))
                       (+ (expt-minus-maclaurin x1 0 k)
                          (-(expt-minus-maclaurin x2 0 k))
                          (expt-minus-maclaurin x3 0 k))))
               (+ (expt-div-fact x1 (+ k 1))
                  (expt-div-fact x2 (+ k 1))
                  (expt-div-fact x3 (+ k 1)))))
 :hints (("Goal"
           :use
           ((:instance abs-expt-error-bound-tri-2)))))


(defthm expt-div-fact-mult
  (implies (and (rationalp x1)
                (rationalp x2)
                (< 0 x1)
                (< 0 x2)
                (natp n))
           (equal (* (expt-div-fact x1 n)
                     (expt-div-fact x2 n))
                  (/ (expt-div-fact (* x1 x2) n)
                     (FACT-1 n))))
:hints (("Goal" 
         :in-theory (enable expt-div-fact)
         ;:induct (expt-div-fact x1 n) 
         ;:in-theory (enable expt-minus-maclaurin)
        ; :induct (expt-minus-maclaurin x1 m n)
))
)

(defthm my-first-bound
  (< (abs (expt-minus-maclaurin 2/3 0 10)) 52/100)
  :rule-classes nil)


(defun n-term-simple (i)
  (/ (+ 1 i)))
(defun big-index-simple ()
  0)

(defthm abs-expt-error-bound-tri-4
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k))
           (<= (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (-(expt-minus-maclaurin x2 0 (+ k 1 n)))
                          (expt-minus-maclaurin x3 0 (+ k 1 n)))
                       (+ (expt-minus-maclaurin x1 0 k)
                          (-(expt-minus-maclaurin x2 0 k))
                          (expt-minus-maclaurin x3 0 k))))
               (+ (expt-div-fact x1 (+ k 1))
                  (expt-div-fact x2 (+ k 1))
                  (expt-div-fact x3 (+ k 1)))))
 :hints (("Goal"
           :use
           ((:functional-instance abs-expt-error-bound-tri-3
                                  (big-index big-index-simple)
                                  (n-term n-term-simple)))
           :in-theory (disable abs-expt-error-bound-tri-3))))



(defthm abs-expt-error-bound-tri-5
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (rationalp x4)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (< 0 x4)
                (natp k)
                (natp n))
           (equal (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                             (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                                (- 1 (expt-minus-maclaurin x3 0 (+ k 1 n))))
                             (-(expt-minus-maclaurin x4 0 (+ k 1 n))))
                          (+ (expt-minus-maclaurin x1 0 k)
                             (* (expt-minus-maclaurin x2 0 k)
                                (- 1 (expt-minus-maclaurin x3 0 k)))
                             (-(expt-minus-maclaurin x4 0 k)))))
                  (abs (+ (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                             (expt-minus-maclaurin x1 0 k))
                          (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (expt-minus-maclaurin x2 0 k))
                          (* (expt-minus-maclaurin x3 0 k)
                             (- (expt-minus-maclaurin x2 0 k)
                                (expt-minus-maclaurin x2 0 (+ k 1 n))))
                          (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (- (expt-minus-maclaurin x3 0 k)
                                (expt-minus-maclaurin x3 0 (+ k 1 n))))
                          (- (expt-minus-maclaurin x4 0 k)
                             (expt-minus-maclaurin x4 0 (+ k 1 n)))))))
  #||  :hints (("Goal"
  :use
  ((:functional-instance abs-expt-error-bound-tri-3
  (big-index big-index-simple)
  (n-term n-term-simple)))
  :in-theory (disable abs-expt-error-bound-tri-3)))||#
)


(defthm abs-expt-error-bound-tri-6
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (rationalp x4)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (< 0 x4)
                (natp k)
                (natp n))
           (<= (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                             (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                                (- 1 (expt-minus-maclaurin x3 0 (+ k 1 n))))
                             (-(expt-minus-maclaurin x4 0 (+ k 1 n))))
                          (+ (expt-minus-maclaurin x1 0 k)
                             (* (expt-minus-maclaurin x2 0 k)
                                (- 1 (expt-minus-maclaurin x3 0 k)))
                             (-(expt-minus-maclaurin x4 0 k)))))
                  (+ (abs (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                             (expt-minus-maclaurin x1 0 k)))
                     (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (expt-minus-maclaurin x2 0 k)))
                     (abs (* (expt-minus-maclaurin x3 0 k)
                             (- (expt-minus-maclaurin x2 0 k)
                                (expt-minus-maclaurin x2 0 (+ k 1 n)))))
                     (abs (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (- (expt-minus-maclaurin x3 0 k)
                                (expt-minus-maclaurin x3 0 (+ k 1 n)))))
                     (abs (- (expt-minus-maclaurin x4 0 k)
                             (expt-minus-maclaurin x4 0 (+ k 1 n))))))))



(defthm abs-expt-mult
  (implies (and (rationalp x1)
                (rationalp x2)
                (< 0 x1)
                (< 0 x2)
                (natp k)
                (natp n))
           (<= (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                  (abs (expt-minus-maclaurin x3 0 k)))
               (abs (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                       (expt-minus-maclaurin x3 0 k))))))


(defthm rationalp-expt-div-fact
  (implies (and (rationalp x)
                (natp n))
           (rationalp (expt-div-fact x n)))
  :hints (("Goal" :in-theory (enable expt-div-fact)))
  :rule-classes :type-prescription)

(defthm rationalp-expt-minus-maclaurin
  (implies (and (rationalp x)
                (natp m)
                (natp n))
           (rationalp (expt-minus-maclaurin x m n)))
  :hints (("Goal" :in-theory (e/d (expt-minus-maclaurin) (evenp))))
  :rule-classes :type-prescription)

(defthm abs-expt-mult-1
  (implies (and (rationalp x1)
                (rationalp x2)
                (< 0 x1)
                (< 0 x2)
                (natp k)
                (natp n))
           (equal (abs (* (expt-minus-maclaurin x1 0 (+ k 1 n))
                       (expt-minus-maclaurin x2 0 k)))
                  (* (abs (expt-minus-maclaurin x1 0 (+ k 1 n)))
                     (abs (expt-minus-maclaurin x2 0 k))))))


(defthm abs-expt-mult-2
  (implies (and (rationalp x2)
                (rationalp x3)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n))
           (equal (abs (* (expt-minus-maclaurin x3 0 k)
                          (- (expt-minus-maclaurin x2 0 k)
                             (expt-minus-maclaurin x2 0 (+ k 1 n)))))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (- (expt-minus-maclaurin x2 0 k)
                             (expt-minus-maclaurin x2 0 (+ k 1 n))))))))
(defthm abs-expt-mult-3
  (implies (and (rationalp x2)
                (rationalp x3)
                (< 0 x2)
                (< 0 x3)
                (natp k)
                (natp n))
           (equal (abs (* (expt-minus-maclaurin x3 0 k)
                          (- (expt-minus-maclaurin x2 0 k)
                             (expt-minus-maclaurin x2 0 (+ k 1 n)))))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (expt-minus-maclaurin x2 0 k)))))))


(defthm abs-expt-error-bound-tri-7
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (rationalp x4)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (< 0 x4)
                (natp k)
                (natp n))
           (<= (+ (abs (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (expt-minus-maclaurin x1 0 k)))
                  (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                          (expt-minus-maclaurin x2 0 k)))
                  (abs (* (expt-minus-maclaurin x3 0 k)
                          (- (expt-minus-maclaurin x2 0 k)
                             (expt-minus-maclaurin x2 0 (+ k 1 n)))))
                  (abs (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                          (- (expt-minus-maclaurin x3 0 k)
                             (expt-minus-maclaurin x3 0 (+ k 1 n)))))
                  (abs (- (expt-minus-maclaurin x4 0 k)
                          (expt-minus-maclaurin x4 0 (+ k 1 n)))))
               (+ (abs (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (expt-minus-maclaurin x1 0 k)))
                  (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                          (expt-minus-maclaurin x2 0 k)))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (expt-minus-maclaurin x2 0 k))))
                  (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                     (abs (- (expt-minus-maclaurin x3 0 (+ k 1 n))
                             (expt-minus-maclaurin x3 0 k))))
                  (abs (- (expt-minus-maclaurin x4 0 (+ k 1 n))
                          (expt-minus-maclaurin x4 0 k))))))
  :hints (("Goal"
 :use
  ((:instance abs-expt-mult-3)))
  ))

(defthm abs-expt-lt-error-bound-1
  (implies (and (rationalp x2)
                (rationalp x3)
                (< 0 x2)
                (< 0 x3)
                (< x3 k)
                (< x2 k)
                (natp k)
                (natp n)
                (<= (big-index) k))
           (<= (* (abs (expt-minus-maclaurin x3 0 k))
                      (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                              (expt-minus-maclaurin x2 0 k))))
               (* (abs (expt-minus-maclaurin x3 0 k))
                  (expt-div-fact x2 (+ k 1)))))
:hints (("Goal"
         :use 
         ((:instance abs-expt-error-bound1 (x x2)))))
)

(defthm abs-expt-lt-error-bound-2
  (implies (and (rationalp x2)
                (rationalp x3)
                (< 0 x2)
                (< 0 x3)
                (< x3 k)
                (< x2 k)
                (natp k)
                (natp n)
                (<= (big-index) k))
           (<= (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                      (abs (- (expt-minus-maclaurin x3 0 (+ k 1 n))
                              (expt-minus-maclaurin x3 0 k))))
               (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                  (expt-div-fact x3 (+ k 1)))))
:hints (("Goal"
         :use 
         ((:instance abs-expt-error-bound1 (x x3)))))
)

(defthm test-lemma
  (implies (and (<= a b)
                (<= c d))
           (<= (+ a c)
               (+ b d))))

(defthm abs-expt-lt-error-bound-3
  (implies (and (rationalp x2)
                (rationalp x3)
                (< 0 x2)
                (< 0 x3)
                (< x3 k)
                (< x2 k)
                (natp k)
                (natp n)
                (<= (big-index) k))
           (<= (+ (* (abs (expt-minus-maclaurin x3 0 k))
                     (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (expt-minus-maclaurin x2 0 k))))
                  (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                     (abs (- (expt-minus-maclaurin x3 0 (+ k 1 n))
                             (expt-minus-maclaurin x3 0 k)))))
               (+ (* (abs (expt-minus-maclaurin x3 0 k))
                     (expt-div-fact x2 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                     (expt-div-fact x3 (+ k 1))))))
  :hints (("Goal"
          :in-theory (disable  abs)
           :use 
           ((:instance abs-expt-lt-error-bound-1)
            (:instance abs-expt-lt-error-bound-2))))
  )

(defthm abs-expt-error-bound-tri-8
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (rationalp x4)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (< 0 x4)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k)
                (< x4 k)
                (<= (big-index) k))
           (<=  (+ (abs (- (expt-minus-maclaurin x1 0 (+ k 1 n))
                           (expt-minus-maclaurin x1 0 k)))
                   (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                           (expt-minus-maclaurin x2 0 k)))
                   (* (abs (expt-minus-maclaurin x3 0 k))
                      (abs (- (expt-minus-maclaurin x2 0 (+ k 1 n))
                              (expt-minus-maclaurin x2 0 k))))
                   (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                      (abs (- (expt-minus-maclaurin x3 0 (+ k 1 n))
                              (expt-minus-maclaurin x3 0 k))))
                   (abs (- (expt-minus-maclaurin x4 0 (+ k 1 n))
                           (expt-minus-maclaurin x4 0 k))))
                (+ (expt-div-fact x1 (+ k 1))
                   (expt-div-fact x2 (+ k 1))
                   (* (abs (expt-minus-maclaurin x3 0 k))
                      (expt-div-fact x2 (+ k 1)))
                   (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                      (expt-div-fact x3 (+ k 1)))
                   (expt-div-fact x4 (+ k 1)))))
  :hints (("Goal"
           :use
           ((:instance abs-expt-error-bound1 (x x1))
            (:instance abs-expt-error-bound1 (x x2))
            (:instance abs-expt-error-bound1 (x x4))
            (:instance abs-expt-lt-error-bound-3)))))

(defthm abs-expt-error-bound-tri-9
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (rationalp x4)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (< 0 x4)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k)
                (< x4 k)
                (<= (big-index) k))
           (<= (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (- 1 (expt-minus-maclaurin x3 0 (+ k 1 n))))
                          (-(expt-minus-maclaurin x4 0 (+ k 1 n))))
                       (+ (expt-minus-maclaurin x1 0 k)
                          (* (expt-minus-maclaurin x2 0 k)
                             (- 1 (expt-minus-maclaurin x3 0 k)))
                          (-(expt-minus-maclaurin x4 0 k)))))
               (+ (expt-div-fact x1 (+ k 1))
                   (expt-div-fact x2 (+ k 1))
                   (* (abs (expt-minus-maclaurin x3 0 k))
                      (expt-div-fact x2 (+ k 1)))
                   (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                      (expt-div-fact x3 (+ k 1)))
                   (expt-div-fact x4 (+ k 1)))))
  :hints (("Goal"
           :in-theory (disable abs)
           :use
            ((:instance abs-expt-error-bound-tri-6)
             (:instance abs-expt-error-bound-tri-7)
             (:instance abs-expt-error-bound-tri-8)))))


(defthm abs-expt-error-bound-tri-10
  (implies (and (rationalp x1)
                (rationalp x2)
                (rationalp x3)
                (rationalp x4)
                (< 0 x1)
                (< 0 x2)
                (< 0 x3)
                (< 0 x4)
                (natp k)
                (natp n)
                (< x1 k)
                (< x2 k)
                (< x3 k)
                (< x4 k))
           (<= (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                          (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                             (- 1 (expt-minus-maclaurin x3 0 (+ k 1 n))))
                          (-(expt-minus-maclaurin x4 0 (+ k 1 n))))
                       (+ (expt-minus-maclaurin x1 0 k)
                          (* (expt-minus-maclaurin x2 0 k)
                             (- 1 (expt-minus-maclaurin x3 0 k)))
                          (-(expt-minus-maclaurin x4 0 k)))))
               (+ (expt-div-fact x1 (+ k 1))
                  (expt-div-fact x2 (+ k 1))
                  (* (abs (expt-minus-maclaurin x3 0 k))
                     (expt-div-fact x2 (+ k 1)))
                  (* (abs (expt-minus-maclaurin x2 0 (+ k 1 n)))
                     (expt-div-fact x3 (+ k 1)))
                  (expt-div-fact x4 (+ k 1)))))
  :hints (("Goal"
           :use
           ((:functional-instance abs-expt-error-bound-tri-9
                                  (big-index big-index-simple)
                                  (n-term n-term-simple)))
           :in-theory (disable abs-expt-error-bound-tri-9))))

(defthm abs-expt-error-bound-tri-10-instance
  (let ((x1 1/2) (x2 1/3) (x3 1/4) (x4 1/5) (k 10) (n 10))
    (< (abs (- (+ (expt-minus-maclaurin x1 0 (+ k 1 n))
                  (* (expt-minus-maclaurin x2 0 (+ k 1 n))
                     (- 1 (expt-minus-maclaurin x3 0 (+ k 1 n))))
                  (-(expt-minus-maclaurin x4 0 (+ k 1 n))))
               (+ (expt-minus-maclaurin x1 0 k)
                  (* (expt-minus-maclaurin x2 0 k)
                     (- 1 (expt-minus-maclaurin x3 0 k)))
                  (-(expt-minus-maclaurin x4 0 k)))))
       (/ 51452756 (expt 10 30))))
  :rule-classes nil)



